diff --git a/jerry-core/ecma/operations/ecma-container-object.c b/jerry-core/ecma/operations/ecma-container-object.c
index 1bc94fb807..7aef572d24 100644
--- a/jerry-core/ecma/operations/ecma-container-object.c
+++ b/jerry-core/ecma/operations/ecma-container-object.c
@@ -698,8 +698,8 @@ ecma_op_container_iterator_next (ecma_value_t this_val, /**< this argument */
   ecma_object_t *obj_p = ecma_get_object_from_value (this_val);
   ecma_extended_object_t *ext_obj_p = (ecma_extended_object_t *) obj_p;
 
-  if (ecma_get_object_type (obj_p) == ECMA_OBJECT_TYPE_PSEUDO_ARRAY
-      && ext_obj_p->u.pseudo_array.type != iterator_type)
+  if (ecma_get_object_type (obj_p) != ECMA_OBJECT_TYPE_PSEUDO_ARRAY
+      || ext_obj_p->u.pseudo_array.type != iterator_type)
   {
     return ecma_raise_type_error (ECMA_ERR_MSG ("Argument 'this' is not an iterator."));
   }
diff --git a/tests/jerry/es2015/regression-test-issue-2950.js b/tests/jerry/es2015/regression-test-issue-2950.js
new file mode 100644
index 0000000000..0f965d2974
--- /dev/null
+++ b/tests/jerry/es2015/regression-test-issue-2950.js
@@ -0,0 +1,23 @@
+// Copyright JS Foundation and other contributors, http://js.foundation
+//
+// Licensed under the Apache License, Version 2.0 (the "License");
+// you may not use this file except in compliance with the License.
+// You may obtain a copy of the License at
+//
+//     http://www.apache.org/licenses/LICENSE-2.0
+//
+// Unless required by applicable law or agreed to in writing, software
+// distributed under the License is distributed on an "AS IS" BASIS
+// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+// See the License for the specific language governing permissions and
+// limitations under the License.
+
+var str = new Map();
+var iterator = str[ Symbol.iterator ]();
+
+try {
+  iterator.next.call({ })
+  assert(false);
+} catch (e) {
+  assert(e instanceof TypeError);
+}
